// SPDX-License-Identifier: MIT

#include <stdio.h>

#include "debug.h"

#include "board.h"

#include "FreeRTOS.h"
#include "task.h"

void vTaskHello(void *pvParameters);

int main(void) {
    /* Initialize board components. */
    BOARD_SystemClock_Config();
    BOARD_IOMUX_Init();
    BOARD_Peripheral_Init();

    /* Initialize UART for libc function calls. */
    USART_Printf_Init(115200);

    printf("Hello world, FreeRTOS?\r\n");

    xTaskCreate(vTaskHello, "HELLO", 256, NULL, 4, NULL);

    vTaskStartScheduler();

    for(;;) {
        /* Never reaches here. */
    }
}


void vTaskHello(void *pvParameters) {
    for(;;) {
        printf("Hello world? @%lu\r\n", xTaskGetTickCount());
        vTaskDelay(pdMS_TO_TICKS(500));
    }
}